#include <stddef.h>
#include <string.h>

#ifndef _WIN32
#include <bios.h>
#include <dos.h>
/* for gotoxy() NTVDM hack */
#include <conio.h>
#else
#include "win32mod.h"
#endif

#include "modsetup.h"

/* 80*25 */
#define SCR_SIZE 2000

#ifndef _WIN32
static WORD scrbuf[SCR_SIZE];
static BYTE scrmod;
static WORD curlen, curpos;
static WORD far *scrmem = MK_FP(0xB800, 0x0000);
#else
static WORD scrmem[SCR_SIZE];
#endif

static char strHint[] = "<Esc> Back  \x18\x19 Move  \x11\xC4\xD9 Selects";
static char strInfo[] = "Press any key to continue";
static char strDlgs[] = "<Esc> Aborts";
static BYTE lines[4][3] = {
  /* /-\ */
  {0xDA, 0xC4, 0xBF},
  /* | | */
  {0xB3, 0x20, 0xB3},
  /* |-| */
  {0xC3, 0xC4, 0xB4},
  /* \-/ */
  {0xC0, 0xC4, 0xD9}
};
static char strMark[2][2][4] = {
  {"( )", "(*)"}, /* v1.4 \x07 */
  {"[ ]", "[v]"}  /* v1.4 \xFB */
};

void SavScreen(WORD *s, int t) {
int i;
  for (i = 0; i < SCR_SIZE; i++) {
    if (t) {
      scrmem[i] = s[i];
    } else {
      s[i] = scrmem[i];
    }
  }
}

#ifndef _WIN32

void UpdScreen(WORD p) {
union REGS rs;
  rs.h.ah = 0x02;
  rs.h.bh = 0x00;
  rs.x.dx = p;
  int86(0x10, &rs, &rs);
}

#else

static CHAR_INFO buf[SCR_SIZE];
void UpdScreen(WORD p) {
SMALL_RECT w;
COORD f, c;
HANDLE h;
int i;
  h = GetStdHandle(STD_OUTPUT_HANDLE);
  if (h) {
    for (i = 0; i < SCR_SIZE; i++) {
      buf[i].Char.AsciiChar = LOBYTE(scrmem[i]);
      buf[i].Attributes = HIBYTE(scrmem[i]);
    }
    c.X = 80;
    c.Y = 25;
    f.X = 0;
    f.Y = 0;
    w.Left = f.X;
    w.Top = f.Y;
    w.Right = c.X - 1;
    w.Bottom = c.Y - 1;
    WriteConsoleOutput(h, buf, c, f, &w);
    c.X = LOBYTE(p);
    c.Y = HIBYTE(p);
    c.Y = (c.Y >= 25) ? 24 : c.Y;
    SetConsoleCursorPosition(h, c);
  }
}

#endif

int Bounds(int vcur, int vmin, int vmax) {
  if (vcur < vmin) { vcur = vmin; }
  if (vcur > vmax) { vcur = vmax; }
  return(vcur);
}

void FillLine(int x, int y, int w, WORD f) {
int i;
  if (y < 25) {
    y *= 80;
    for (i = 0; i < w; i++) {
      if ((x + i) < 80) {
        scrmem[y + x + i] = f;
      }
    }
  }
}

void TxtPrint(int x, int y, char *s) {
  x = Bounds(x, 0, 79);
  y = Bounds(y, 0, 24);
  y *= 80;
  for (; *s; s++) {
    if ((x < 80) && ((y + x) < SCR_SIZE)) {
      scrmem[y + x] = (scrmem[y + x] & 0xFF00) | ((BYTE) *s);
      x++;
    }
  }
  UpdScreen(0x1900);
}

void DrawItem(int x, int y, menuitem *item, WORD t) {
int i, k;
  k = (item->flag & (ITEM_CHKBOX | ITEM_RADBOX)) ? 4 : 0;
  if (item->flag & ITEM_GRAYED) {
    t = t ? 0x7800 : 0x1800;
  } else {
    t = t ? 0xF100 : 0x1F00;
  }
  for (i = 0; item->item[i]; i++) {
    if ((x + i) < 80) {
      scrmem[(y*80) + k + x + i] = (scrmem[(y*80) + k + x + i] & 0x00FF) | t;
    }
  }
  if (k) {
    FillLine(x, y, 4, (item->flag & ITEM_GRAYED) ? 0x1820 : 0x1F20);
    TxtPrint(x, y, strMark[(item->flag & ITEM_CHKBOX) ? 1 : 0][(item->flag & ITEM_HILITE) ? 1 : 0]);
  }
  TxtPrint(x + k, y, item->item);
}

void HintText(char *s) {
  FillLine(0, 24, 80, 0x7020);
  if (s) {
    TxtPrint((80 - strlen(s)) / 2, 24, s);
  }
}

void DrawLine(int x, int y, int w, int t) {
int i, k;
  for (i = 0; i < w; i++) {
    k = 1;
    if ((i == 0)) {
      k = 0;
    }
    if (i == (w - 1)) {
      k = 2;
    }
    scrmem[(y*80) + x + i] = (scrmem[(y*80) + x + i] & 0xFF00) | lines[t][k];
  }
}

void DrawRect(int x, int y, int w, int h, WORD a) {
int i, j;
  /* menu */
  for (j = 0; j < h; j++) {
    FillLine(x, y + j, w, a);
  }
  /* right shadow */
  for (j = 1; j < h; j++) {
    for (i = 0; i < 2; i++) {
      if ((x + w + i) < 80) {
        scrmem[((y + j)*80) + x + w + i] = (scrmem[((y + j)*80) + x + w + i] & 0x00FF) | 0x0800;
      }
    }
  }
  /* bottom shadow */
  j = y + h;
  if (j < 24) {
    j *= 80;
    x += 2;
    for (i = 0; i < w; i++) {
      if ((x + i) < 80) {
        scrmem[j + x + i] = (scrmem[j + x + i] & 0x00FF) | 0x0800;
      }
    }
  }
}

#ifndef _WIN32
#define VK_UP     0x48
#define VK_DOWN   0x50
#define VK_LEFT   0x4B
#define VK_RIGHT  0x4D
#define VK_ESCAPE 0x01
#define VK_BACK   0x0E
#define VK_RETURN 0x1C
#define VK_SPACE  0x39
#define VK_HOME   0x47
#define VK_END    0x4F
#endif

int DoMenu(int x, int y, menuitem *items, PMENUPROC mp) {
BYTE key;
int i, j;
  for (i = 0; i < (items[0].flag & MENU_ITEMSK); i++) {
    if ((items[i + 1].flag & ITEM_CHKBOX) || (items[i + 1].flag & ITEM_HILITE)) {
      break;
    }
  }
  if (i >= (items[0].flag & MENU_ITEMSK)) {
    i = 0;
  }
  do {
    HintText(items[i + 1].hint);
    DrawItem(x, y + i, &items[i + 1], 1);
    key = ((WORD) bioskey(0)) >> 8;
    DrawItem(x, y + i, &items[i + 1], 0);
    switch (key) {
      case VK_UP:
        j = i;
        do {
          i = (i > 0) ? (i - 1) : ((items[0].flag & MENU_ITEMSK) - 1);
        } while ((j != i) && (items[1 + i].flag & ITEM_GRAYED) && (!items[1 + i].item[0]));
        break;
      case VK_DOWN:
        j = i;
        do {
          i = ((i + 1) < (items[0].flag & MENU_ITEMSK)) ? (i + 1) : 0;
        } while ((j != i) && (items[1 + i].flag & ITEM_GRAYED) && (!items[1 + i].item[0]));
        break;
      case VK_HOME:
        i = 0;
        break;
      case VK_END:
        i = (items[0].flag & MENU_ITEMSK) - 1;
        break;
      case VK_BACK:
        key = VK_ESCAPE;
        break;
      case VK_SPACE:
        key = VK_RETURN;
      case VK_RETURN:
        if (items[i + 1].flag & ITEM_GRAYED) {
          key = 0;
        } else {
          if (items[i + 1].flag & (ITEM_CHKBOX | ITEM_RADBOX)) {
            if (items[i + 1].flag & ITEM_CHKBOX) {
              items[i + 1].flag ^= ITEM_HILITE;
            } else {
              /* drop old selection */
              for (j = 0; j < (items[0].flag & MENU_ITEMSK); j++) {
                if ((items[j + 1].flag & ITEM_RADBOX) && (items[j + 1].flag & ITEM_HILITE)) {
                  /* not the same */
                  if (i != j) {
                    items[j + 1].flag ^= ITEM_HILITE;
                    DrawItem(x, y + j, &items[j + 1], 0);
                  }
                  break;
                }
              }
              /* select current */
              items[i + 1].flag |= ITEM_HILITE;
            }
            key = 0;
          }
          if (mp) {
            j = mp(i + 1);
            if (j) { key = 0; }
            /* special case: redraw/update this menu items */
            if (j == -1) {
              for (j = 0; j < (items[0].flag & MENU_ITEMSK); j++) {
                DrawItem(x, y + j, &items[j + 1], 0);
              }
            }
          }
        }
        break;
    }
  } while ((key != VK_ESCAPE) && (key != VK_RETURN));
  return((key == VK_RETURN) ? (i + 1) : 0);
}

int DrawMenu(menuitem *items, PMENUPROC mp) {
WORD back[SCR_SIZE];
int i, x, y, w, h, t, d;
char *s;
  /* save screen buffer */
  SavScreen(back, 0);
  /* dialog width */
  w = 0;
  /* dialog height */
  h = 6;
  h += (items[0].flag & MENU_ITEMSK);
  for (i = 0; i < (items[0].flag & MENU_ITEMSK); i++) {
    t = strlen(items[i + 1].item) + ((items[i + 1].flag & (ITEM_CHKBOX | ITEM_RADBOX)) ? 4 : 0);
    if (w < t) { w = t; }
  }
  /* d - max item width */
  d = w;
  t = strlen(items[0].item);
  if (w < t) { w = t; }
  /* dialog default bottom line */
  switch (items[0].flag & MENU_TYPMSK) {
    case MENU_NFOBOX:
      s = strInfo;
      break;
    case MENU_DLGBOX:
      s = strDlgs;
      break;
    default:
      s = strHint;
      break;
  }
  t = strlen(s);
  if (w < t) { w = t; }
  if (items[0].hint) {
    t = strlen(items[0].hint);
    if (w < t) { w = t; }
    /* hint line + separator line */
    h += 2;
  }
  /* width */
  w += 4;
  w = Bounds(w, 4, 80);
  h = Bounds(h, 4, 23);
  x = Bounds((80 - w) / 2, 0, 79);
  y = Bounds((25 - h) / 2, 1, 23);
  DrawRect(x, y, w, h, 0x1B20);
  /* text graphics */
  for (i = 0; i < h; i++) {
    t = 1;
    if (i == 0) {
      t = 0;
    }
    if (i == (h - 1)) {
      t = 3;
    }
    if ((i == 2) || (i == (h - 3))) {
      t = 2;
    }
    if (items[0].hint && (i == 4)) {
      t = 2;
    }
    DrawLine(x, y + i, w, t);
  }
  /* header */
  TxtPrint(x + (w - strlen(items[0].item)) / 2, y + 1, items[0].item);
  /* t - position from dialog top */
  t = 3;
  /* subheader */
  if (items[0].hint) {
    /* green color */
    i = (w - strlen(items[0].hint) - 4) / 2;
    FillLine(x + 2, y + 3, w - 4, 0x1A20);
    TxtPrint(x + 2 + i, y + 3, items[0].hint);
    t += 2;
  }
  /* bottom hint */
  TxtPrint(x + ((w - strlen(s)) / 2), y + h - 2, s);
  /* center menu items if needed */
  /*switch (items[0].flag & MENU_TYPMSK) {
    case MENU_DLGBOX:*/
      d = ((w - d - 4) / 2);
/*      break;
    default:
      d = 0;
      break;
  }*/
  for (i = 0; i < (items[0].flag & MENU_ITEMSK); i++) {
    DrawItem(x + 2 + d, y + t + i, &items[i + 1], 0);
  }
  /* do actions */
  switch (items[0].flag & MENU_TYPMSK) {
    case MENU_NFOBOX:
      t = ((((WORD) bioskey(0)) >> 8) != VK_ESCAPE) ? 1 : 0;
      break;
    default:
      t = DoMenu(x + 2 + d, y + t, items, mp);
      break;
  }
  /* restore screen buffer */
  SavScreen(back, 1);
  return(t);
}

int DrawInfo(menuitem *item, PMENUPROC mp) {
WORD back[SCR_SIZE];
int i, t, x, y, w, h;
char *s;
  /* save screen buffer */
  for (i = 0; i < SCR_SIZE; i++) {
    back[i] = scrmem[i];
  }
  s = item->hint;
  if (item->flag) {
    s = s ? s : strInfo;
  }
  x = s ? strlen(s) : 0;
  h = 2 + (item->item ? 1 : 0) + (s ? 2 : 0);
  w = item->item ? strlen(item->item) : 0;
  w = (x > w) ? x : w;
  w += 4;
  w = Bounds(w, 4, 80);
  h = Bounds(h, 3, 5);
  x = Bounds((80 - w) / 2, 0, 79);
  y = Bounds((25 - h) / 2, 1, 23);
  DrawRect(x, y, w, h, item->flag ? 0x4F20 : 0x4E20);
  for (i = 0; i < h; i++) {
    t = 1;
    if (i == 0) {
      t = 0;
    }
    if (i == (h - 1)) {
      t = 3;
    }
    DrawLine(x, y + i, w, t);
  }
  if (item->item) {
    TxtPrint(x + ((w - strlen(item->item)) / 2), y + 1, item->item);
  }
  if (s) {
    FillLine(x + 2, y + 1 + 2, w - 4, 0x4720);
    TxtPrint(x + ((w - strlen(s)) / 2), y + 1 + 2, s);
  }
  /* call user proc or just wait for key */
  if (mp) {
    x = mp(0);
  } else {
    bioskey(0);
    x = 0;
  }
  /* restore screen buffer */
  for (i = 0; i < SCR_SIZE; i++) {
    scrmem[i] = back[i];
  }
  return(x);
}

int DrawTest(menuitem *items, PMENUPROC mp) {
WORD stat[17]; /* max items in one screen menu */
int i;
  /* will use as flag later */
  stat[0] = 0;
  /* save menu states */
  for (i = 0; i < (items[0].flag & MENU_ITEMSK); i++) {
    if (i < 17) {
      /* save item value */
      stat[i] = GetMenuData(items[1 + i]);
      /* also save states for radio or check boxes */
      if (items[1 + i].flag & (ITEM_RADBOX | ITEM_CHKBOX)) {
        stat[i] |= items[1 + i].flag & ITEM_HILITE;
      }
    }
  }
  DrawMenu(items, mp);
  /* check if anything changes */
  for (i = 0; i < (items[0].flag & MENU_ITEMSK); i++) {
    if (i < 17) {
      /* xor (drop) item value */
      stat[i] ^= GetMenuData(items[1 + i]);
      /* xor (drop) select state for radio or check boxes */
      if (items[1 + i].flag & (ITEM_RADBOX | ITEM_CHKBOX)) {
        stat[i] ^= (items[1 + i].flag & ITEM_HILITE);
      }
      /* still not zero - something changed */
      if (stat[i]) {
        /* set flag*/
        stat[0] = 1;
        break;
      }
    }
  }
  return(stat[0]);
}

void DefMenuItem(menuitem *menu, int item) {
int i;
  i = menu[0].flag & MENU_ITEMSK;
  while (i--) {
    SET_LITE(menu[1 + i], i == item);
  }
}

#ifndef _WIN32

void InitSetup(char *l, char *r) {
union REGS rs;
int i;
  /* save screen buffer */
  SavScreen(scrbuf, 0);
  /* get current mode */
  rs.h.ah = 0x0F;
  int86(0x10, &rs, &rs);
  scrmod = rs.h.al;
  /* get current cursor info */
  rs.h.ah = 0x03;
  rs.h.bh = 0x00;
  int86(0x10, &rs, &rs);
  curlen = rs.x.cx;
  curpos = rs.x.dx;
  /* set mode 80x25 */
  rs.h.ah = 0x00;
  rs.h.al = 0x03;
  int86(0x10, &rs, &rs);
  /* hide cursor */
  rs.h.ah = 0x01;
  rs.x.cx = 0x2020;
  int86(0x10, &rs, &rs);
  /* disable blinking */
  rs.x.ax = 0x1003;
  rs.h.bl = 0;
  int86(0x10, &rs, &rs);
  /* fast keyboard */
  rs.x.ax = 0x0305;
  rs.x.bx = 0x0000;
  int86(0x16, &rs, &rs);
  /* draw background */
  for (i = 0; i < SCR_SIZE; i++) {
    scrmem[i] = ((i < 80) || (i >= 80*24)) ? 0x7020 : 0x80B0;
  }
  TxtPrint(79 - strlen(r), 0, r);
  TxtPrint(1, 0, l);
  UpdScreen(0x1900);
}

void FreeSetup(void) {
union REGS rs;
  /* enable blinking */
  rs.x.ax = 0x1003;
  rs.h.bl = 1;
  int86(0x10, &rs, &rs);
  /* restore video mode */
  rs.h.ah = 0x00;
  rs.h.al = scrmod;
  int86(0x10, &rs, &rs);
  /* show cursor */
  rs.h.ah = 0x01;
  rs.x.cx = curlen;
  int86(0x10, &rs, &rs);
  /* restore videomemory */
  SavScreen(scrbuf, 1);
  UpdScreen(0);
  /* NTVDM text screen update */
  gotoxy((curpos & 0xFF) + 1, (curpos >> 8) + 1);
}

#else

void InitSetup(char *l, char *r) {
CONSOLE_CURSOR_INFO cci;
SMALL_RECT m;
HANDLE h;
COORD c;
DWORD i;
  ZeroMemory(scrmem, sizeof(scrmem));
  if (AllocConsole()) {
    h = GetStdHandle(STD_OUTPUT_HANDLE);
    if (h) {
      /* window title */
      SetConsoleTitle(l);
      /* set console font if possible */
      ChangeConsoleFontSize(h);
      /* set window size */
      c.X = 80;
      c.Y = 25;
      m.Left = 0;
      m.Top = 0;
      m.Right = c.X - 1;
      m.Bottom = c.Y - 1;
      /* set windows size first */
      SetConsoleWindowInfo(h, TRUE, &m);
      /*
        "If you try to make the screen buffer smaller than the window size, the call will fail."
        (c) https://web.archive.org/web/20110917150900/http://www.adrianxw.dk/SoftwareSite/Consoles/Consoles6.html
      */
      SetConsoleScreenBufferSize(h, c);
      /* hide cursor */
      cci.dwSize = 1;
      cci.bVisible = FALSE;
      SetConsoleCursorInfo(h, &cci);
    }
  }
  /* draw background */
  for (i = 0; i < SCR_SIZE; i++) {
    scrmem[i] = ((i < 80) || (i >= 80*24)) ? 0x7020 : 0x80B0;
  }
  TxtPrint(79 - strlen(r), 0, r);
  TxtPrint(1, 0, l);
  UpdScreen(0x1900);
}

void FreeSetup(void) {
  FreeConsole();
}

#endif
