/* for NULL */
#include <stddef.h>
#include "shapedit.h"
#include "modsetup.h"
#include "patchack.h"

static menuitem crosshair[] = {
  {"Shape editor", NULL, 12 | MENU_DLGBOX},
  {"1**********", NULL, ITEM_GRAYED},
  {"2**********", NULL, ITEM_GRAYED},
  {"3**********", NULL, ITEM_GRAYED},
  {"4**********", NULL, ITEM_GRAYED},
  {"5**********", NULL, ITEM_GRAYED},
  {"* 1 2 3 4 5", NULL, ITEM_GRAYED},
  {"Change row *", "Select row for pixel to change.", 0},
  {"Change col *", "Select column for pixel to change.", 0},
  {"Toggle pixel", "Toggle pixel on or off.", 0},
  {"", NULL, ITEM_GRAYED},
  {"Save and on", "Save current shape and enable crosshair.", 0},
  {"Cancel and off", "Do not save any changes and disable crosshair (<Esc> - do nothing, return back).", 0}
};

static char c_shape[5][5];
static int c_col, c_row;

char GetDrawChar(int j, int i) {
char c;
  if ((j == c_row) && (i == c_col)) {
    c = c_shape[j][i] ? '\xB2' : '\xB1';
  } else {
    c = c_shape[j][i] ? '\xDB' : '\xB0';
  }
  return(c);
}

void ReDrawMenu(void) {
int i, j;
char c;
  crosshair[7].item[11] = '1' + c_row;
  crosshair[8].item[11] = '1' + c_col;
  for (j = 0; j < 5; j++) {
    for (i = 0; i < 5; i++) {
      c = GetDrawChar(j, i);
      crosshair[1 + j].item[1 + (i * 2)] = c;
      crosshair[1 + j].item[1 + (i * 2) + 1] = c;
    }
  }
}

int CrosshairProc(int item) {
  if ((item >= 7) && (item <= 9)) {
    /* toggle */
    if (item == 9) {
      c_shape[c_row][c_col] ^= 1;
    } else {
      /* new coords */
      if (item == 7) {
        c_row = (c_row + 1) % 5;
      } else {
        c_col = (c_col + 1) % 5;
      }
    }
    ReDrawMenu();
    /* force to update menu */
    item = -1;
  }
  /* save / cancel */
  if (item >= 11) {
    item = 0;
  }
  return(item);
}

int EditCrosshair(void *data) {
fix_item *p;
int i, j, k;
  /* load cursor data */
  p = (fix_item *) data;
  for (j = 0; j < 5; j++) {
    for (i = 0; i < 5; i++) {
      c_shape[j][i] = p[(i * 5) + (4 - j)].data ? 1 : 0;
    }
  }
  c_col = 2;
  c_row = 2;
  ReDrawMenu();
  DefMenuItem(crosshair, 6);
  k = DrawMenu(crosshair, CrosshairProc);
  /* save cursor data */
  if (k == 11) {
    for (j = 0; j < 5; j++) {
      for (i = 0; i < 5; i++) {
        p[(i * 5) + (4 - j)].data = c_shape[j][i] ? 0x15 : 0x00;
      }
    }
    i = 1;
  } else {
    i = k ? 2 : 0;
  }
  return(i);
}
